''This program demonstrates the use of the counter in POS detector with feedback to perform ADC
''calculations.
CON
_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000
' At 80MHz the ADC/DAC sample resolutions and rates are as follows:
' sample sample
' bits rate
' ----------------
' 5 2.5 MHz
' 6 1.25 MHz
' 7 625 KHz
' 8 313 KHz
' 9 156 KHz
' 10 78 KHz
' 11 39 KHz
' 12 19.5 KHz
' 13 9.77 KHz
' 14 4.88 KHz

bits = 14       'try different values from table here

fbpin = 17       'feedback pin (BPIN)
adcpin = 16      'feedin pin (APIN)

OBJ
LCD : "LCD_16X2_8BIT"
VAR long value
PUB go
LCD.start
cognew(@asm_entry, @value) 'launch assembly program into a COG
LCD.CLEAR                       'clear the screen
repeat
  waitcnt(40_000_000 + cnt) 'wait 1/2 second until updating
    LCD.CLEAR
    LCD.MOVE(3,1)
    LCD.DEC(value) 'write the value to the screen
DAT
' Assembly program
org
asm_entry mov dira,asm_dira 'make pins 8 (ADC) and 0 (DAC) outputs
movs ctra,#adcpin 'POS W/FEEDBACK mode for CTRA
movd ctra,#fbpin
movi ctra,#%01001_000
mov frqa,#1
mov asm_cnt,cnt 'prepare for WAITCNT loop
add asm_cnt,asm_cycles
:loop waitcnt asm_cnt,asm_cycles 'wait for next CNT value
mov asm_sample,phsa 'capture PHSA and get difference
sub asm_sample,asm_old
add asm_old,asm_sample
wrlong asm_sample, par 'write the value to main memory
jmp #:loop 'wait for next sample period
' Data
asm_cycles long |< bits - 1 'sample time
asm_dira long |< fbpin 'output mask
asm_cnt res 1
asm_old res 1
asm_sample res 1
